// AlphaTokenizer.h
//	Copyright:	 1994 - 1996 by Apple Computer, Inc., all rights reserved.

#pragma once
#ifndef AlphaTokenizer_h
#define AlphaTokenizer_h

#pragma import on

#include "IAAnalysis.h"
#include "IACharStream.h"

#pragma IA_BEGIN_EXPORTS

const AlphaTokenizerMaxTokenLen = 63;

class AlphaTokenizer : public IATokenStream {
public:
			AlphaTokenizer(IACharStream* stream);
//			AlphaTokenizer(AlphaTokenizer& sts) : IATokenStream(sts) {}
			~AlphaTokenizer();  			// deletes charStream
	IAToken*			GetNextToken();
	void				GetTextSpan(byte* buffer, uint32 startPos, uint32 endPos);

protected:	
	void 			SetCharStream (IACharStream* cStream) {charStream = cStream;}
	IACharStream* 	GetCharStream() {return charStream;}
	void 			SetStreamBuffer(char* sBuffer) {buffer = sBuffer;}
	char* 			GetStreamBuffer() {return buffer;}
	
private:
	IACharStream*		charStream;
	char*				buffer;
};

#pragma IA_END_EXPORTS

#pragma import reset

#endif
